;===============================================================================
;
;	PS/2 Mouse & Keybord and SFC pad code transfer
;				by piro
; 
;
;		Original Program(PPCA)	: K.Takahashi(tokoya)
;               
;	V0.1.1 
;     F7 key bug fix
;===============================================================================
;AT90S2313
;----------------------
;  +----__----+
; 1|          |20
; 2|          |19
; 3|  AVR     |18
; 4|          |17
; 5|AT90S2313 |16
; 6|          |15
; 7|          |14
; 8|          |13
; 9|          |12
;10|          |11
;  +----------+
;
; Xtal 8 MHz
; 
; 1:~RESET
; 2:PD0(RXD)----> 74HC04 pin 4
; 3:PD1(TXD)----> 74HC04 pin 1
; 4:XTAL2
; 5:XTAL1
; 6:PD2(INT0)<--- ps/2 keyboard clock
; 7:PD3(INT1)<--- ps/2 mouse clock
; 8:PD4<--------- ps/2 keyboard data
; 9:PD5<--------- ps/2 mouse data
;10:GND
;11:PD6--------->
;12:PB0---------> sfc P/S
;13:PB1---------> sfc clock
;14:PB2<--------- sfc data
;15:PB3--------->
;16:PB4--------->
;17:PB5--------->
;18:PB6--------->
;19:PB7--------->
;20:VCC+5V

.include "2313def.inc"

.def	prev_byte1 = r1					; pad prev data1
.def	prev_byte2 = r2					; pad prev data2
.def	joy_loop = r21

.def	tmp		= r4
.def	tmp2		= r5
.def	mtx_cmd		= r6				; mouseւ̑MR}h
.def	mtx_opt		= r7				; mouseւ̑MIvV
.def	mtx_code	= r8				; mouseւ̑MR[h
.def	send_count	= r9
.def	kb_count	= r10				; L[{[h̎MR[h
.def	ms_count	= r11				; }EX̎MR[h

.def	tx_cmd		= r12				; L[{[hւ̑MR}h
.def	tx_opt		= r13				; L[{[hւ̑MIvV
.def	rx_code		= r14				; L[{[h̎MR[h
.def	tx_code		= r15				; L[{[hւ̑MR[h

.def	tp_main		= r16				; C[N
.def	tp_int		= r17				; 荞ݓgp[N
.def	tp_send		= r18				; zXgւ̑MLN^
.def	i0_code		= r19
.def	i0_count	= r20
.def	i1_code		= r23
.def	i1_count	= r26
.def	pt_count	= r3				; peBJEg
.def	tx_count	= r22
.def	fg_key		= r24
							; bit2 - edge_flag
							; bit3 - e0_flag
							; bit4 - e1_flag
							; bit5 - Medge_flag
							; bit6 - Me0_flag
							; bit7 - Me1_flag
.def	fg_txrx		= r25
							; bit0 - tx_request
							; bit1 - tx_option
							; bit2 - rx_busy
							; bit3 - rx_wait
							; bit4 - Mtx_request
							; bit5 - Mtx_option
							; bit6 - Mrx_busy
							; bit7 - Mrx_wait
.def	led_stat	= r27
							; bit0 - Scroll Lock
							; bit1 - Num Lock
							; bir2 = Caps Lock
.def	fg_cmd		= r28
							; bit0 - 1Byte Command
							; bit1 - 2Byte Command(First)
							; bit2 - 2Byte Command(Second)
							; bit3 - LED Set
.def	ack_flag	= r29
							; bit0 - kb_ack
							; bit1 - ms_ack

.equ	EDGE_FLAG	= 2
.equ	E0_FLAG		= 3
.equ	E1_FLAG		= 4
.equ	MEDGE_FLAG	= 5
.equ	ME0_FLAG	= 6
.equ	ME1_FLAG	= 7

.equ	TX_REQUEST	= 0
.equ	TX_OPTION	= 1
.equ	RXC_WAIT	= 2
.equ	RX_BUSY		= 3
.equ	MTX_REQUEST	= 4
.equ	MTX_OPTION	= 5
.equ	MRXC_WAIT	= 6
.equ	MRX_BUSY	= 7

.equ	KB_ACK		= 0
.equ	MS_ACK		= 1

.equ	KB_CLK		= 2
.equ	KB_DATA		= 4
.equ	MS_CLK		= 3
.equ	MS_DATA		= 5

.equ	SCROLL_LOCK	= 0
.equ	NUM_LOCK	= 1
.equ	CAPS_LOCK	= 2

.equ	X1BYTE_CMD	= 0
.equ	X2BYTE_CMD_F	= 1
.equ	X2BYTE_CMD_S	= 2
.equ	LED_SET		= 3
.equ	MX1BYTE_CMD	= 4
.equ	MX2BYTE_CMD_F	= 5
.equ	MX2BYTE_CMD_S	= 6


	.dseg
	.org $60
;-- Buffer area --
kbbf_st:	
	.byte 4
kbbf_ed:

prekbbf_st:
	.byte 4
prekbbf_ed:

msbf_st:	
	.byte 4
msbf_ed:


.CSEG
.ORG	$0
		rjmp	RESET
		rjmp	EXT_INT0				; L[{[h荞
		rjmp	EXT_INT1				; }EX荞
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	UART_RXC				; VAM荞
		rjmp	DUMMY
		rjmp	DUMMY
		rjmp	DUMMY

DUMMY:
		reti

;---------------------------------------
;	
;---------------------------------------
RESET:
		ldi	tp_main,low(RAMEND)			; X^bN|C^ݒ
		out	SPL,tp_main
	
		ldi	tp_main,0b11100011			; |[gaPB234͂ɐݒ
		out	DDRB,tp_main
		ldi	tp_main,0b00011100			; vAbv
		out	PORTB,tp_main

		ldi	tp_main,0b01000011			; |[gcPD5`PD2͂ɐݒ
		out	DDRD,tp_main
		ldi	tp_main,0b00000000			; vAbv
		out	PORTD,tp_main

		ldi	tp_main,(1<<ISC01) + (1<<ISC11)	; INT0&INT1Ŋ荞ݔ
		out	MCUCR,tp_main



		ldi	tp_main,0b10011000			; MAM荞݋
		out	UCR,tp_main


		ldi	tp_main,51					; NbN8MHzUBRRl51 (9600bps)
		sbis	pinb,4
		ldi	tp_main,12					; UBRR value 12(36800bps)
		sbis	pinb,3
		ldi	tp_main,25					; UBRR value 25(19200bps)
		
		sbic	pinb,4
		rjmp	uart_set
		sbic	pinb,3
		rjmp	uart_set
		ldi		tp_main,8				; UBRR value 8(57600bps)

uart_set:	
		out	UBRR,tp_main

		clr	i0_code						; [NWX^
		ldi	i0_count,11
		clr	i1_code						; [NWX^
		ldi	i1_count,11
		clr	fg_key
		clr	fg_txrx
		clr	led_stat
		clr	fg_cmd
		clr	ack_flag
		ldi	tp_main,1
		mov	ms_count,tp_main
		mov	kb_count,tp_main

		ldi	tp_main,(1<<INT0)+(1<<INT1)	; INT0&INT1荞݋
		out	GIMSK,tp_main
		sei								; 荞݋

;---------------------------------------
;	C[v
;---------------------------------------
MAIN:
		cbr	fg_txrx,(1<<RXC_WAIT)+(1<<MRXC_WAIT)		; MʒmtONA
		clr	rx_code
MAIN_RX_0:

JOY_CHECK:	

joy_start:								; clock & p/s pulse send
	sbi		portb,1
	sbi		portb,0
	rcall	wait_5us
	cbi		portb,0
	cbi		portb,1


;	sfc joystick first byte read
	ldi		joy_loop,8
	clr		tmp
first_byte:
	lsl		tmp
	clr		tp_main
	sbis	pinb,2						; data bit check
	ldi		tp_main,0b00000001
	or		tmp,tp_main

	rcall	wait_5us

	sbi		portb,1						; colck pluse send
	rcall	wait_5us
	cbi		portb,1

	dec		joy_loop
	brne	first_byte

	

;	sfc joystick second byte read
	ldi		joy_loop,8
	clr		tmp2
second_byte:
	lsl		tmp2
	clr		tp_main
	sbis	pinb,2						; data bit check
	ldi		tp_main,0b00000001
	or		tmp2,tp_main

	rcall	wait_5us					; clock pluse send
	sbi		portb,1
	rcall	wait_5us
	cbi		portb,1

	dec		joy_loop
	brne	second_byte

	rcall	wait_5us					; wait for joy_start


	mov		tp_main,tmp					; prevew data check 
	eor		tp_main,prev_byte1
	brne	send_joy
	mov		tp_main,tmp2
	eor		tp_main,prev_byte2
	breq	JOY_END
	


send_joy:	
	ldi		tp_main,'J'					; send Joystick Mark
	mov		tp_send,tp_main
	rcall	SEND
	ldi		tp_main,2					; joystick xommand count; tp_main for check sum
	mov		tp_send,tp_main
	rcall	SEND
	mov		tp_send,tmp
	add		tp_main,tmp
	rcall	SEND
	mov		tp_send,tmp2
	add		tp_main,tmp2
	rcall	SEND
	mov		tp_send,tmp2				; spacer
	add		tp_main,tmp2
	rcall	SEND
	mov		tp_send,tp_main				; send check sum
	rcall	SEND
	
	
	mov		prev_byte1,tmp
	mov		prev_byte2,tmp2
	rjmp	JOY_END


wait_5us:				
	ldi		tp_main,12				; total 40 clock * 0.125us = 5.000us	
wait_5us_loop:
	dec		tp_main		
	brne	wait_5us_loop
	ret

MAIN_RX_0x:
	rjmp	MAIN_RX_0

	


JOY_END:

		sbrc	fg_txrx,TX_REQUEST		; keyboardMvtOĂH
		rjmp	MAIN_RX_1
		sbrc	fg_txrx,MTX_REQUEST		; mouseMvtOĂH
		rjmp	MAIN_MRX_1
		sbrc	fg_txrx,RXC_WAIT		; MtOĂM
		rjmp	MAIN_RX_2
		sbrc	fg_txrx,MRXC_WAIT		; MtOĂM
		rjmp	MAIN_MRX_2
		rjmp	MAIN_RX_0
MAIN_RX_1:
		sbrc	fg_txrx,RX_BUSY			; MrȂ犮܂ő҂
		brne	MAIN_RX_0x
		rjmp	MAIN_TX

MAIN_MRX_1:
		sbrc	fg_txrx,MRX_BUSY		; MrȂ犮܂ő҂
		brne	MAIN_RX_0x
		rjmp	MAIN_MTX

;
; zXgփL[R[hM
;
MAIN_RX_2:
		rcall	SEND_KB					; XLR[ĥ܂ܑo
		rjmp	MAIN

;
; zXgփL[R[hM
;
MAIN_MRX_2:
		rcall	SEND_MS					; XLR[ĥ܂ܑo
		rjmp	MAIN

MAIN_TX:
	;
	; L[{[hփR}hM
	;
		mov	tx_code,tx_cmd
		rcall	SEND_TO_KB				; L[{[hɃR}hM
		rcall	RX_WAIT					; ACKM
		sbrs	fg_txrx,TX_OPTION
		rjmp	MAIN_TX_0
		mov	tx_code,tx_opt
		rcall	SEND_TO_KB				; L[{[hɃIvVM
		rcall	RX_WAIT					; ACKM
MAIN_TX_0:
		cbr	fg_txrx,(1<<TX_REQUEST)		; MvtONA
		cbr	fg_txrx,(1<<TX_OPTION)		; IvVMtONA
		cbr	ack_flag,(1<<KB_ACK)		; Ack Flag clear
		rjmp	MAIN				

;---------------------------------------
;	M҂
;---------------------------------------
RX_WAIT:
		cbr	fg_txrx,(1<<RXC_WAIT)		; MʒmtONA
		sbr	ack_flag,(1<<KB_ACK)		; ACK recieve flag set
		clr	rx_code
RX_WAIT_0:
		sbrs	fg_txrx,RXC_WAIT		; MtOĂM
		rjmp	RX_WAIT_0
		ret

;
; mouseփR}hM
;
MAIN_MTX:

		mov	mtx_code,mtx_cmd
		rcall	SEND_TO_MS				; L[{[hɃR}hM
		rcall	MRX_WAIT				; ACKM
		sbrs	fg_txrx,MTX_OPTION
		rjmp	MAIN_MTX_0
		mov	mtx_code,mtx_opt
		rcall	SEND_TO_MS				; L[{[hɃIvVM
		rcall	MRX_WAIT				; ACKM
MAIN_MTX_0:
		cbr	fg_txrx,(1<<MTX_REQUEST)	; MvtONA
		cbr	fg_txrx,(1<<MTX_OPTION)		; IvVMtONA
		cbr	ack_flag,(1<<MS_ACK)		; Ack Flag clear 
		rjmp	MAIN				

;---------------------------------------
;	mouse M҂
;---------------------------------------
MRX_WAIT:
		cbr	fg_txrx,(1<<MRXC_WAIT)		; MʒmtONA
		sbr	ack_flag,(1<<MS_ACK)		; ACK recieve flag set
		clr	rx_code
MRX_WAIT_0:
		sbrs	fg_txrx,MRXC_WAIT		; MtOĂM
		rjmp	MRX_WAIT_0
		ret

;---------------------------------------
;	M
;---------------------------------------
SEND_MS:
		ldi	tp_main,'M'					; Send Mouse Mark
		mov	tp_send,tp_main
		rcall	SEND

		ldi	ZL,low(msbf_st)				; }EX̃XLR[h̃AhX
		ldi	ZH,high(msbf_st)
		ld	send_count,Z				; Scancode Length (= 3) }EX͌Œ

		rjmp	DATA_SEND

SEND_KB:

		ldi	ZL,low(kbbf_st)				; L[{[h̃XLR[h̃AhX
		ldi	ZH,high(kbbf_st)
		ld	send_count,Z


SEND_KB1:								; ÕXLR[hƔrAłΑoȂB
		ldi	ZL,low(kbbf_st)			
		ldi	ZH,high(kbbf_st)
		add	ZL,send_count
		ld	tmp,Z
		ldi	ZL,low(prekbbf_st)
		ldi	ZH,high(prekbbf_st)
		add	ZL,send_count
		ld	tmp2,Z
		eor	tmp,tmp2
		brne	SEND_KB2

		dec	send_count
		brne	SEND_KB1
		rjmp	SEND_EXIT

SEND_KB2:
		ldi	ZL,low(kbbf_st)
		ldi	ZH,high(kbbf_st)
		ld	send_count,Z

SEND_KB3:								; ̃XLR[hۑ
		ldi	ZL,low(kbbf_st)
		ldi	ZH,high(kbbf_st)
		add	ZL,send_count
		ld	tmp,Z
		ldi	ZL,low(prekbbf_st)
		ldi	ZH,high(prekbbf_st)
		add	ZL,send_count
		st	Z,tmp

		dec	send_count
		brne	SEND_KB3


		ldi	ZL,low(kbbf_st)
		ldi	ZH,high(kbbf_st)
		ld	send_count,Z

		ldi	tp_main,'K'					; Send Keyboard Mark
		mov	tp_send,tp_main
		rcall	SEND
		clr	tp_main						; tp_main for check sum

DATA_SEND:
		mov	tp_send,send_count
		rcall	SEND

		ldi	tp_main,3
		mov	send_count,tp_main
		mov	tp_main,tp_send					; tp_main for check sum

		
DATA_SEND_LOOP:

		inc	ZL
		ld	tp_send,Z
		rcall	SEND
		add	tp_main,tp_send
		dec	send_count
		brne	DATA_SEND_LOOP

		mov	tp_send,tp_main
		rcall	SEND

SEND_EXIT:
		ret

;
;  SEND TO UART
;
				
SEND:
		sbis	USR,UDRE				; MI܂ő҂
		rjmp	SEND
		out	UDR,tp_send
		ret


;---------------------------------------
;	L[{[hփR}hM
;---------------------------------------
SEND_TO_KB:
		cli								; 荞݋֎~

		cbi	PORTD,KB_CLK				; CLK|[go͂Lɐݒ
		cbi	PORTD,KB_DATA				; DATA|[go͂Lɐݒ
		sbi	DDRD,KB_CLK					; |[gcPD2(KB_CLK)o͂ɐݒ(Lo)

		ldi	tp_main,128					; 64Sec҂(0.125Secx4x128=64Sec)
SEND_TO_KB_0:
		nop
		dec	tp_main
		brne	SEND_TO_KB_0

		sbi	DDRD,KB_DATA				; |[gcPD4(KB_DATA)o͂ɐݒ(Lo)(X^[grbg)
		cbi	DDRD,KB_CLK					; |[gcPD2(KB_CLK)͂ɐݒ

		ldi	tx_count,8
		clr	pt_count
		rcall	CLK_HIGHLOW				; CLK̗҂

SEND_TO_KB_1:
		ror	tx_code						; 1rbgEVtg
		brcs	SEND_TO_KB_2
		sbi	DDRD,KB_DATA				; Lo
		rjmp	SEND_TO_KB_3
SEND_TO_KB_2:
		cbi	DDRD,KB_DATA				; Ho(vAbvHɂȂ)
		inc	pt_count					; peBJEg
SEND_TO_KB_3:
		rcall	CLK_HIGHLOW				; CLK̗҂
		dec	tx_count
		brne	SEND_TO_KB_1

		sbrc	pt_count,0				; H
		rjmp	SEND_TO_KB_4
		cbi	DDRD,KB_DATA				; Lo(peBrbg)
		rjmp	SEND_TO_KB_5
SEND_TO_KB_4:		
		sbi	DDRD,KB_DATA				; Ho(peBrbg)
SEND_TO_KB_5:						
		rcall	CLK_HIGHLOW				; CLK̗҂
		cbi	DDRD,KB_DATA				; Ho(Xgbvrbg)

		rcall	CLK_HIGHLOW				; CLK̗҂
		sbis	PIND,KB_DATA			; ACK?
		rjmp	SEND_TO_KB_6
		
		ldi	tp_main,0xFF
		mov	tx_code,tp_main				; ZbgR}h
		rjmp	SEND_TO_KB		

SEND_TO_KB_6:
		sbis	PIND,KB_CLK				; CAChԂɂȂ܂ő҂
		rjmp	SEND_TO_KB_6

		clr	i0_code						; [NWX^
		ldi	i0_count,11
		clr	fg_key

		sei
		ret

;---------------------------------------
;	CLK̗҂
;---------------------------------------
CLK_HIGHLOW:
		sbis	PIND,KB_CLK
		rjmp	CLK_HIGHLOW
CLK_HIGHLOW_0:
		sbic	PIND,KB_CLK
		rjmp	CLK_HIGHLOW_0
		ret

;---------------------------------------
;	MouseփR}hM
;---------------------------------------
SEND_TO_MS:
		cli								; 荞݋֎~

		cbi	PORTD,MS_CLK				; CLK|[go͂Lɐݒ
		cbi	PORTD,MS_DATA				; DATA|[go͂Lɐݒ
		sbi	DDRD,MS_CLK					; |[gcPD3(MS_CLK)o͂ɐݒ(Lo)

		ldi	tp_main,128					; 64Sec҂(0.125Secx4x128=64Sec)
SEND_TO_MS_0:
		nop
		dec	tp_main
		brne	SEND_TO_MS_0

		sbi	DDRD,MS_DATA				; |[gcPD5(MS_DATA)o͂ɐݒ(Lo)(X^[grbg)
		cbi	DDRD,MS_CLK					; |[gcPD3(MS_CLK)͂ɐݒ

		ldi	tx_count,8
		clr	pt_count
		rcall	MSCLK_HIGHLOW			; CLK̗҂

SEND_TO_MS_1:
		ror	mtx_code					; 1rbgEVtg
		brcs	SEND_TO_MS_2
		sbi	DDRD,MS_DATA				; Lo
		rjmp	SEND_TO_MS_3
SEND_TO_MS_2:
		cbi	DDRD,MS_DATA				; Ho(vAbvHɂȂ)
		inc	pt_count					; peBJEg
SEND_TO_MS_3:
		rcall	MSCLK_HIGHLOW			; CLK̗҂
		dec	tx_count
		brne	SEND_TO_MS_1

		sbrc	pt_count,0				; H
		rjmp	SEND_TO_MS_4
		cbi	DDRD,MS_DATA				; Lo(peBrbg)
		rjmp	SEND_TO_MS_5
SEND_TO_MS_4:		
		sbi	DDRD,MS_DATA				; Ho(peBrbg)
SEND_TO_MS_5:						
		rcall	MSCLK_HIGHLOW			; CLK̗҂
		cbi	DDRD,MS_DATA				; Ho(Xgbvrbg)

		rcall	MSCLK_HIGHLOW			; CLK̗҂
		sbis	PIND,MS_DATA			; ACK?
		rjmp	SEND_TO_MS_6
		
		ldi	tp_main,0xFF
		mov	mtx_code,tp_main			; ZbgR}h
		rjmp	SEND_TO_MS		

SEND_TO_MS_6:
		sbis	PIND,MS_CLK				; CAChԂɂȂ܂ő҂
		rjmp	SEND_TO_MS_6

		clr	i1_code						; [NWX^
		ldi	i1_count,11
		clr	fg_key

		sei
		ret

;---------------------------------------
;	Mouse CLK̗҂
;---------------------------------------
MSCLK_HIGHLOW:
		sbis	PIND,MS_CLK
		rjmp	MSCLK_HIGHLOW
MSCLK_HIGHLOW_0:
		sbic	PIND,MS_CLK
		rjmp	MSCLK_HIGHLOW_0
		ret

;---------------------------------------
;	L[{[h荞
;---------------------------------------
EXT_INT0:
		in	r0,SREG						; SREGWX^Ҕ
		push	r0
		push	tp_int

		sbr	fg_txrx,(1<<RX_BUSY)		; MtO𗧂Ă

		sbrc	fg_key,EDGE_FLAG		; オ̊荞݁H
		rjmp	EXT_INT0_1

		cpi	i0_count,11					; peBAX^[grbgAXgbvrbg͏
		brsh	EXT_INT0_0
		cpi	i0_count,3
		brlo	EXT_INT0_0
		lsr	i0_code
		sbic	PIND,PD4
		ori	i0_code,0x80

EXT_INT0_0:
		in	tp_int,MCUCR
		ori	tp_int,(1<<ISC01)+(1<<ISC00)	; オł̊荞ݔɐݒ
		out	MCUCR,tp_int
		sbr	fg_key,(1<<EDGE_FLAG)		; tOZbg
		rjmp	EXT_INT0_EXIT

EXT_INT0_1:
		in	tp_int,MCUCR
		andi	tp_int,~(1<<ISC00)		; ł̊荞ݔɐݒ
		out	MCUCR,tp_int
		cbr	fg_key,(1<<EDGE_FLAG)		; tONA
		dec	i0_count					; SrbgMH
		brne	EXT_INT0_EXIT


		mov	rx_code,i0_code				; MR[h
		clr	i0_code
		ldi	i0_count,11

		sbrc	ack_flag,KB_ACK			; ACK mode check
		rjmp	EXT_INT0_2
		sbrs	rx_code,7				; extended flag?
		rjmp	EXT_INT0_2  
		sbrs	rx_code,6				; extended flag?
		rjmp	EXT_INT0_2  
		ldi	ZL,low(kbbf_st)				; obt@ɃXgA 
		ldi	ZH,high(kbbf_st)
		add	ZL,kb_count
		st	Z,rx_code
		inc	kb_count
		rjmp	EXT_INT0_EXIT
		
EXT_INT0_2:						
		ldi	ZL,low(kbbf_st)				; obt@ɃXgA(ŏIoCg)
		ldi	ZH,high(kbbf_st)
		st	Z,kb_count
		add	ZL,kb_count
		st	Z,rx_code
		clr	kb_count
		inc	kb_count
		sbr	fg_txrx,(1<<RXC_WAIT)		; MʒmtO𗧂Ă
		cbr	fg_txrx,(1<<RX_BUSY)		; MtONA

EXT_INT0_EXIT:	
		pop	tp_int
		pop	r0							; SREGWX^𕜋A
		out	SREG,r0
		reti							; 荞݂߂

;---------------------------------------
;	}EX荞
;---------------------------------------
EXT_INT1:
		in	r0,SREG						; SREGWX^Ҕ
		push	r0
		push	tp_int

		sbr	fg_txrx,(1<<MRX_BUSY)		; MtO𗧂Ă

		sbrc	fg_key,MEDGE_FLAG		; オ̊荞݁H
		rjmp	EXT_INT1_1

		cpi	i1_count,11					; peBAX^[grbgAXgbvrbg͏
		brsh	EXT_INT1_0
		cpi	i1_count,3
		brlo	EXT_INT1_0
		lsr	i1_code
		sbic	PIND,PD5
		ori	i1_code,0x80

EXT_INT1_0:
		in	tp_int,MCUCR
		ori	tp_int,(1<<ISC11)+(1<<ISC10)	; オł̊荞ݔɐݒ
		out	MCUCR,tp_int
		sbr	fg_key,(1<<MEDGE_FLAG)		; tOZbg
		rjmp	EXT_INT1_EXIT

EXT_INT1_1:
		in	tp_int,MCUCR
		andi	tp_int,~(1<<ISC10)		; ł̊荞ݔɐݒ
		out	MCUCR,tp_int
		cbr	fg_key,(1<<MEDGE_FLAG)		; tONA
		dec	i1_count					; SrbgMH
		brne	EXT_INT1_EXIT


		mov	rx_code,i1_code				; MR[h
		clr	i1_code
		ldi	i1_count,11

		sbrc	ack_flag,MS_ACK			; ACK mode check
		rjmp	EXT_INT1_2
		mov	tp_int,ms_count				; 3oCgMH
		cpi	tp_int,3
		breq	EXT_INT1_2
		ldi	ZL,low(msbf_st)				; obt@ɃXgA
		ldi	ZH,high(msbf_st)
		add	ZL,ms_count
		st	Z,rx_code
		inc	ms_count
		rjmp	EXT_INT1_EXIT
		
EXT_INT1_2:
		ldi	ZL,low(msbf_st)				; obt@ɃXgA(ŏIoCg)
		ldi	ZH,high(msbf_st)
		st	Z,ms_count
		add	ZL,ms_count
		st	Z,rx_code
		clr	ms_count
		inc	ms_count
		sbr	fg_txrx,(1<<MRXC_WAIT)		; MʒmtO𗧂Ă
		cbr	fg_txrx,(1<<MRX_BUSY)		; MtONA

EXT_INT1_EXIT:	
		pop	tp_int
		pop	r0							; SREGWX^𕜋A
		out	SREG,r0
		reti							; 荞݂߂

;---------------------------------------
;	VAM荞
;---------------------------------------
UART_RXC:
		in	r0,SREG						; SREGWX^Ҕ
		push	r0
		push	tp_int
		push	tp_main

		in	tp_int,UDR
		tst	fg_cmd
		breq	UART_RXC_SKIP_00
		rjmp	UART_RXC_CMD

UART_RXC_SKIP_00:
		cpi	tp_int,'V'					; o[W
		brne	UART_RXC_SKIP_2
		ldi	tp_send,'P'
		rcall	SEND
		ldi	tp_send,'S'
		rcall	SEND
		ldi	tp_send,'2'
		rcall	SEND
		ldi	tp_send,'S'
		rcall	SEND
		ldi	tp_send,'E'
		rcall	SEND
		ldi	tp_send,'R'
		rcall	SEND
		ldi	tp_send,' '
		rcall	SEND
		ldi	tp_send,'V'
		rcall	SEND
		ldi	tp_send,'0'
		rcall	SEND
		ldi	tp_send,'.'
		rcall	SEND
		ldi	tp_send,'1'
		rcall	SEND
		ldi	tp_send,'.'
		rcall	SEND
		ldi	tp_send,'1'
		rcall	SEND
		rjmp	UART_RXC_EXIT
	
UART_RXC_SKIP_2:
		cpi	tp_int,'L'					; LEDԎ擾
		brne	UART_RXC_SKIP_3
		mov	tp_send,led_stat
		ori	tp_send,0x30
		rcall	SEND
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_3:
		cpi	tp_int,'R'					; L[{[hZbg
		brne	UART_RXC_SKIP_4
		sbr	fg_txrx,(1<<TX_REQUEST)
		ldi	tp_main,0xFF
		mov	tx_cmd,tp_main
		clr	led_stat					; LEDԃNA
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_4:
		cpi	tp_int,'E'					; LEDԐݒ
		brne	UART_RXC_SKIP_5
		sbr	fg_cmd,(1<<LED_SET)
		rjmp	UART_RXC_EXIT
		
UART_RXC_SKIP_5:
		cpi	tp_int,'K'					; keyboard 1ByteR}h
		brne	UART_RXC_SKIP_6
		sbr	fg_cmd,(1<<X1BYTE_CMD)
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_6:
		cpi	tp_int,'k'					; keyboard 2ByteR}h
		brne	UART_RXC_SKIP_10
		sbr	fg_cmd,(1<<X2BYTE_CMD_F)
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_10:
		cpi	tp_int,'r'					; mouse reset
		brne	UART_RXC_SKIP_11
		sbr	fg_txrx,(1<<MTX_REQUEST)
		ldi	tp_main,0xFF
		mov	mtx_cmd,tp_main
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_11:
		cpi	tp_int,'e'					; mouse enable
		brne	UART_RXC_SKIP_12
		sbr	fg_txrx,(1<<MTX_REQUEST)
		ldi	tp_main,0xF4
		mov	mtx_cmd,tp_main
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_12:
		cpi	tp_int,'M'					; mouse 1ByteR}h
		brne	UART_RXC_SKIP_13
		sbr	fg_cmd,(1<<MX1BYTE_CMD)
		rjmp	UART_RXC_EXIT

UART_RXC_SKIP_13:
		cpi	tp_int,'m'					; mouse 2ByteR}h
		brne	UART_RXC_EXIT
		sbr	fg_cmd,(1<<MX2BYTE_CMD_F)
		rjmp	UART_RXC_EXIT

UART_RXC_CMD:
		sbrs	fg_cmd,LED_SET
		rjmp	UART_RXC_CMD_0
		sbr	fg_txrx,(1<<TX_REQUEST)
		sbr	fg_txrx,(1<<TX_OPTION)
		ldi	tp_main,0xED
		mov	tx_cmd,tp_main
		andi	tp_int,0x07
		mov	tx_opt,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT
		
UART_RXC_CMD_0:
		sbrs	fg_cmd,X1BYTE_CMD
		rjmp	UART_RXC_CMD_1
		sbr	fg_txrx,(1<<TX_REQUEST)
		mov	tx_cmd,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT

UART_RXC_CMD_1:
		sbrs	fg_cmd,X2BYTE_CMD_S
		rjmp	UART_RXC_CMD_2
		sbr	fg_txrx,(1<<TX_REQUEST)
		sbr	fg_txrx,(1<<TX_OPTION)
		mov	tx_opt,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT

UART_RXC_CMD_2:
		sbrs	fg_cmd,X2BYTE_CMD_F
		rjmp	UART_MRXC_CMD_0
		mov	tx_cmd,tp_int
		sbr	fg_cmd,(1<<X2BYTE_CMD_S)
		rjmp	UART_RXC_EXIT

UART_MRXC_CMD_0:
		sbrs	fg_cmd,MX1BYTE_CMD
		rjmp	UART_MRXC_CMD_1
		sbr	fg_txrx,(1<<MTX_REQUEST)
		mov	mtx_cmd,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT

UART_MRXC_CMD_1:
		sbrs	fg_cmd,MX2BYTE_CMD_S
		rjmp	UART_MRXC_CMD_2
		sbr	fg_txrx,(1<<MTX_REQUEST)
		sbr	fg_txrx,(1<<MTX_OPTION)
		mov	mtx_opt,tp_int
		clr	fg_cmd
		rjmp	UART_RXC_EXIT

UART_MRXC_CMD_2:
		sbrs	fg_cmd,MX2BYTE_CMD_F
		rjmp	UART_RXC_EXIT
		mov	mtx_cmd,tp_int
		sbr	fg_cmd,(1<<MX2BYTE_CMD_S)
		rjmp	UART_RXC_EXIT

UART_RXC_EXIT:
		pop	tp_main
		pop	tp_int
		pop	r0							; SREGWX^𕜋A
		out	SREG,r0
		reti							; 荞݂߂
